import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The world to the prototype: or the scenario, technically.
 * 
 * @Fernando Duarte 
 * @5.0
 */
public class BackYard extends greenfoot.World
{
    private int score;
    private int time;
    /**
     * Constructor for objects of class BackYard.
     * 
     */
    public BackYard()
    {    
        // Create a new world with 900x500 cells with a cell size of 1x1 pixels.
        super(900, 500, 1); 
        score = 0;
        time = 800;
        showScore();
        showTime();
        prepare();
    }

    private void showScore()
    {
        // Show the score.
        showText("Score: " + score, 62, 25);
    } 

    private void showTime()
    {
        // Show the time.
        showText("Time: " + time, 77, 45);
    }

    public void addScore(int points)
    {
        //Add points to the score. Specify points when calling this method.
        score = score + points;
        showScore();
    }

    public void act()
    {
        //When the score reaches at least 70, the game is over.
        if (score >= 70)
        {
            Greenfoot.playSound("fanfare.wav"); 
            Greenfoot.playSound("dog_bark2.wav");
            Greenfoot.stop();
            showText("You are a Good Boy now! You Win!", 315, 200);
        }
        countTime();
        
         if(Greenfoot.getRandomNumber(200)<=1)
        {
            addObject(new badCar(), 0, Greenfoot.getRandomNumber(400));
        }
    }

    private void countTime()
    {
        //Count down the timer.
        time--;
        showTime();
        if (time == 0)
        {
            showEndMessage();
            Greenfoot.stop();
        }
    }

    private void showEndMessage()
    {
        //If time is up, show the final score before time ended.
        showText("Time is up!", 450, 260);
        showText("Your final score: " + score + " points", 450, 300);
    }
    
    public void showEndMessage2()
    {
        showText("You were ran over!", 450, 260);
        showText("Your final score: "+ score + "points", 450, 300);
    }

    /**
     * Prepare the world for the start of the program.
     * That is: create the initial objects and add them to the world.
     */
    private void prepare()
    {
        int x, y;
        spawner spawner = new spawner();
        addObject(spawner,117,228);
        for (int i = 0; i < 6; i++)
        {
            x = Greenfoot.getRandomNumber(600)+100;
            y = Greenfoot.getRandomNumber(400)+100;
            addObject(new Bread(), x, y);
        }
        
        for (int i = 0; i < 5; i++)
        {
            x = Greenfoot.getRandomNumber(800)+100;
            y = Greenfoot.getRandomNumber(300)+100;
            addObject(new Mouse(), x, y);
        }

        for (int i = 0; i < 1; i++)
        {
            x = Greenfoot.getRandomNumber(600)+100;
            y = Greenfoot.getRandomNumber(300)+100;
            addObject(new BadBoy(), x, y);
        }
        
        for (int i = 0; i < 2; i++)
        {
            x = Greenfoot.getRandomNumber(450)+100;
            y = Greenfoot.getRandomNumber(300)+100;
            addObject(new Bug(), x, y);
        }

        for (int i = 0; i < 2; i++)
        {
            x = Greenfoot.getRandomNumber(600)+250;
            y = Greenfoot.getRandomNumber(300)+100;
            addObject(new Cat(), x, y);
        }

        for (int i = 0; i < 1; i++)
        {
            x = Greenfoot.getRandomNumber(550)+100;
            y = Greenfoot.getRandomNumber(300)+100;
            addObject(new Turtle(), x, y);
        }
        for (int i = 0; i < 1; i++)
        {
            x = Greenfoot.getRandomNumber(30)+70;
            y = Greenfoot.getRandomNumber(300)+100;
            addObject(new badCar(), x, y);
        }
    }
}

