import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Bug-eater. If you eat two bugs, your score boosts up 30.
 * 
 * @Andrew McLay 
 * @2.0
 */
public class Turtle extends Actor
{
    private int bugsEaten;
    private boolean gotBonus = false;
    private GreenfootImage image1;
    private GreenfootImage image2;
    /**
     * Act - do whatever the Turtle wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public Turtle()
    {
        image1 = new GreenfootImage("turtle2.png");
        image2 = new GreenfootImage("turtle3.png");
    }
    public void act() 
    {
        moveAndTurn();
        BonusScore();
        lookForBug();
    }
    // Add Score System.
    public void moveAndTurn()
    {

        if (Greenfoot.isKeyDown("w"))
        {
            move(3);
            updateImage();
        }    

        if (Greenfoot.isKeyDown("s"))
        {
            move(-3);
            updateImage();
        }

        if (Greenfoot.isKeyDown("q"))
        {
            turn(-4);
            updateImage();
        }

        if (Greenfoot.isKeyDown("e"))
        {
            turn(4);
            updateImage();
        }
    }
    
    public void lookForBug()
    {
        Actor bug;
        bug = getOneObjectAtOffset(0, 0, Bug.class);
        if (bug != null)
        {
            World world;
            world = getWorld();
            world.removeObject(bug);
            Greenfoot.playSound("slurp.wav");
            bugsEaten++;
        }

    }
     public void updateImage()
    {
        if (getImage() == image1)
        {
            setImage(image2);
        }    
        else
        {
            setImage(image1);
        }
    }
    public void BonusScore()
    {
        if (bugsEaten == 2 && gotBonus == false)  
        {Greenfoot.playSound("success.wav");
            BackYard backyard = (BackYard)getWorld();
            backyard.addScore(30);
            gotBonus = true;
        }
    }
}
